<template>
  <div
    data-component-group="auth-form"
    data-component="reset-pass"
  >
    <Form
      :title="$t('views.reset.title')"
      second-title="Set new password"
    >
      <v-text-field
        v-model="password"
        label="New password"
        :append-icon="isPasswordVisible ? 'visibility_off' : 'visibility'"
        required
        :type="isPasswordVisible ? 'text' : 'password'"
        :error-messages="passErrors"
        @blur="$v.password.$touch()"
        @click:append="isPasswordVisible = !isPasswordVisible"
      />

      <div class="form-actions">
        <v-btn
          flat
          class="trigger"
          :loading="isLoading"
          @click="submit"
        >
          {{ 'Set password and login' }}
        </v-btn>
      </div>
    </Form>
  </div>
</template>

<script>
  import { validationMixin } from 'vuelidate';
  import { required, minLength } from 'vuelidate/lib/validators';
  import colors from 'vuetify/es5/util/colors';
  import Form from '../Form.vue';
  import router from '../../../router';
  import { config, hasLowercase, hasUppercase, hasSpecialSymbol } from '../../../validators/password';

  const pass = { ...config };

  export default {
    components: {
      Form,
    },
    mixins: [validationMixin],
    validations: {
      password: {
        required,
        minLength: minLength(pass.length),
        hasLowercase,
        hasUppercase,
        hasSpecialSymbol
      }
    },
    data: () => ({
      password: '',
      isPasswordVisible: false,
      isLoading: false,
      isSubmitted: false,
      colors,
    }),
    computed: {
      passErrors() {
        const errors = [];
        if (!this.$v.password.$dirty) {
          return errors;
        }
        if (!this.$v.password.minLength) {
          errors.push(
            router.app.$t('components.forms.login.errors.password_length').replace('{0}', pass.length)
          );
        }
        if (!this.$v.password.required) {
          errors.push(router.app.$t('components.forms.login.errors.password_required'));
        }
        if (!this.$v.password.hasLowercase) {
          errors.push(router.app.$t('components.forms.login.errors.password_lowercase'));
        }
        if (!this.$v.password.hasUppercase) {
          errors.push(router.app.$t('components.forms.login.errors.password_uppercase'));
        }
        if (!this.$v.password.hasSpecialSymbol) {
          errors.push(router.app.$t('components.forms.login.errors.password_special_symbol'));
        }
        return errors;
      }
    },
    created() {
      this.$store.watch(() => {
        const isLogged = this.$store.getters['auth/isLogged'];
        const hasErrors = this.$store.getters['alerts/error'].length > 0;

        if (hasErrors || (this.isSubmitted && isLogged)) {
          this.isLoading = false;
        }
      }, () => {});
    },
    methods: {
      submit() {
        this.$v.$touch();

        if (!this.canSubmitRequest() || this.$v.pending || this.$v.invalid) {
          return false;
        }

        this.resetPass();
      },
      clear() {
        this.$v.$reset();
        this.password = '';
        this.isSubmitted = false;
      },
      canSubmitRequest() {
        return this.password !== '';
      },
      resetPass() {
        const { token } = this.$route.params;
        const { email } = this.$store.getters['auth/user'];

        this.isLoading = true;
        this.isSubmitted = true;
        this.$store.dispatch('auth/resetPass', {
          token,
          email,
          password: this.password
        });
      }
    },
  };
</script>

<style lang="stylus" scoped>
  [data-component-group="auth-form"] {
    &[data-component="reset-pass"] {
      width: 100%;
    }
  }
</style>
